import java.io.*;
import java.net.*;
import java.util.*;

class Server_info{
   String web_add;
   String hostname;
   int port;
   String homedir;
   
   public Server_info()
   {
    web_add = new String();
    hostname = new String();
    homedir = new String();
   }
}

class My_Server_info {
 static  Server_info[] info = new Server_info[20];
 static File infofile;
 static FileInputStream Fin;
 static DataInputStream Din;
 static String temp = new String();
 static int tot_sers;
  

  static void init()
  {
   infofile = new File("Server.info");

   if(!infofile.isFile())
   {
     System.out.println("Error: no such file");
     return;
    }
    if(!infofile.canRead())
    {
      System.out.println("Error: unable to read file");
      return;
    }
    try {
      Fin = new FileInputStream(infofile);
    }
    catch(IOException e) { System.out.println("Error :" + e);
                           return;
                         }
    Din = new DataInputStream(Fin);

    try {
      temp = Din.readLine();
    }
    catch(IOException e) { System.out.println("Error :" + e);
                           return;
                         }
    int i = 0;
    while(temp != null)
    {
     StringTokenizer t = new StringTokenizer(temp, " ");
     info[i] = new Server_info();
     info[i].web_add = t.nextToken();
     info[i].hostname = t.nextToken();
     info[i].port = Integer.parseInt(t.nextToken());
     info[i].homedir = t.nextToken();
     i++;
     try {
       temp = Din.readLine();
     }
     catch(IOException e) { System.out.println("Error :" + e);
                           return;
                         }
    }
    tot_sers = i;
  }

  static String Gethost(String webser)
  {
   for(int i = 0; i < tot_sers; i++)
   {
     if(info[i].web_add.equalsIgnoreCase(webser))
     {
        return(info[i].hostname);
     }
   }
   return((String)null);
  }

  static int Getport(String webser)
  {
   for(int i = 0; i < tot_sers; i++)
   {
     if(info[i].web_add.equalsIgnoreCase(webser))
     {
        return(info[i].port);
     }
   }
   return(-1);
  }

  static String Gethome()
  {
   for(int i = 0; i < tot_sers; i++)
   {
     if(info[i].hostname.equalsIgnoreCase("myhost"))
     {
        return(info[i].homedir);
     }
   }
   return((String)null);
  }

}


public class Server extends Thread {
    public final static int DEFAULT_PORT = 6789;
    protected int port;
    protected ServerSocket listen_socket;
    
    // Exit with an error message, when an exception occurs.
    public static void fail(Exception e, String msg) {
        System.err.println(msg + ": " +  e);
        System.exit(1);
    }
    
    // Create a ServerSocket to listen for connections on;  
    // start the thread.

    public Server(int port) {
        if (port == 0) port = DEFAULT_PORT;
        this.port = port;
        try { listen_socket = new ServerSocket(port); }
        catch (IOException e) {fail(e, 
                   "Exception creating server socket");}
        System.out.println("Server: listening on port " + port);
        this.start();
    }
    
    // The body of the server thread.  Loop forever, listening for and
    // accepting connections from clients.  For each connection, 
    // create a Connection object to handle communication through the
    // new Socket.
    public void run() {
        try {
            while(true) {
                Socket client_socket = listen_socket.accept();
                Appli_Connection c = new Appli_Connection(client_socket, 
                          port);
            }
        }
        catch (IOException e) {fail(e, 
                "Exception while listening for connections");}
    }
    
    // Start the server up, listening on an optionally specified port
    public static void main(String[] args) {
        int port = 0;
        My_Server_info.init();
        if (args.length == 1) {
            try {port = Integer.parseInt(args[0]); }
            catch (NumberFormatException e) {port = 0;}
        }
        new Server(port);
    }
}

// This class is the thread that handles all communication with a client

class Appli_Connection extends Thread {
    protected Socket client;
    protected DataInputStream in, in1;;
    protected PrintStream out, out1;
    int port;
    File file;
    FileInputStream fin, Fin;
    FileOutputStream fout, Fout;
    private String[] entries;
    StringBuffer str;
    File dir;
    URL temp_url;
    Socket s;
    String line1;
    String actual_file;
    InputStream ins;
    StringBuffer data_str;

    // Initialize the streams and start the thread
    public Appli_Connection(Socket client_socket, int port) {
        client = client_socket;
        this.port = port;
        str = new StringBuffer();
        try { 
            in = new DataInputStream(client.getInputStream());
            out = new PrintStream(client.getOutputStream());
        }
        catch (IOException e) {
            try {client.close(); }catch (IOException e2) {;}
            System.err.println(
                     "Exception while getting socket streams: " + e);
            return;
        }
        this.start();
    }

    public void Send_err(String Error)
    {
     StringBuffer err_msg = new StringBuffer();
     err_msg.append(String.valueOf(0));
     err_msg.append("|");
     err_msg.append(Error);
     System.out.println("PRINTING ERROR IN SAVE: SERVER " + Error);
     out.println(err_msg.toString());
    }


    public void open_file(String req, String filename)
    {
       try {
         temp_url = new URL(filename);
         } catch(MalformedURLException me)
           {
            System.out.println("Error in URL: " + me);
            Send_err("Malformed URL");
            return;
           }

       if(!temp_url.getHost().equals(""))
       {
        /*If there is no server running on that machine*/
        if(My_Server_info.Gethost(temp_url.getHost()) == null)
        {
         try {
         ins = temp_url.openStream();
         }
         catch(IOException e) {Send_err("Unknown URL"); return; }

         byte[] data = new byte[1024];
         int bytes_read = 0;

         data_str = new StringBuffer();
         while(bytes_read != -1)
         {
           try {
             bytes_read = ins.read(data);
          }
          catch(IOException e) { Send_err("Error :" + e);
                                  return;
                                }
          if(bytes_read != -1)
          data_str.append(new String(data, 0, 0, bytes_read));
          }
          str = new StringBuffer();
          str.append(String.valueOf(3));
          str.append("|");
          int tot_size =  data_str.toString().length();
          str.append(String.valueOf(tot_size));
          out.println(str.toString());
          System.out.print("SERVER SENDING" + str.toString());

          str = null;
          str = new StringBuffer();

          str.append(data_str);
          System.out.print("SERVER SENDING" + str.toString());
          out.print(str.toString());

         return;
        }
       }
       if((temp_url.getHost().equals(""))||
          (My_Server_info.Gethost(temp_url.getHost()).equals("myhost")))
       {

        if(temp_url.getHost().equals(""))
           actual_file = temp_url.getFile();
        else
        {
         actual_file = (new StringBuffer
         (My_Server_info.Gethome())).append(temp_url.getFile()).toString();
        }

        System.out.println("ACTUAL FILE " + actual_file);

        System.out.println("ENTERED REGULAR STYLE");
        dir = new File(actual_file);

        if ((!dir.isDirectory()) && (!dir.isFile()))
        {
         Send_err("Error: no such file or directory");
         return;
        }

        if(dir.isDirectory())
        {
          if(!dir.canRead())
          {
            Send_err("Error: unable to read directory");
            return; 
          }

          System.out.println("RECVED " + filename);
          entries = dir.list();

          str.append(String.valueOf(1));
          str.append("|");
          for(int i = 0; i < entries.length; i++)
          {
            str.append(entries[i]);
            str.append("|");
          }
          out.println(str.toString());
  
         System.out.println("SENDING " + str);
       }
       else if(dir.isFile())
       {
          if(!dir.canRead())
	  {  
            Send_err("Error: unable to read file");
	    return;
	  } 

          System.out.println("RECVED " + filename);

          int size = (int) dir.length();

          int bytes_read = 0;

          try {
            Fin = new FileInputStream(dir);
          }
          catch(IOException e) { Send_err("Error :" + e);
				 return;
			       }	

          byte[] data = new byte[size];

          while(bytes_read < size)
          {
           try {
              bytes_read += Fin.read(data, bytes_read, size-bytes_read);
           }
           catch(IOException e) { Send_err("Error :" + e);
  				  return;
			        }	
          }
          str.append(String.valueOf(2));
          str.append("|");
          int tot_size =  (new String(data, 0)).length(); 
          str.append(String.valueOf(tot_size));
          out.println(str.toString());
          System.out.print("SERVER SENDING" + str.toString());

          str = null;
          str = new StringBuffer();

          str.append(new String(data, 0));
          System.out.print("SERVER SENDING" + str.toString());
          out.print(str.toString());
       }
     }
     else
     {
      try
      {
       System.out.println(" OPENING to " + 
                          My_Server_info.Gethost(temp_url.getHost()) + 
                          " PORT " + 
                          My_Server_info.Getport(temp_url.getHost()));

       s = new Socket(My_Server_info.Gethost(temp_url.getHost()),
                             My_Server_info.Getport(temp_url.getHost()));
       in1  = new DataInputStream(s.getInputStream());
       out1 = new PrintStream(s.getOutputStream());
      }
      catch(IOException e) { 
               Send_err(e + "Exception creating Server Server socket");
               return;
              }
      String data = new String();
      try {
          /*Send the file name to the server*/
          out1.println(req);

          /*Get a header packet*/
          data = in1.readLine();
          System.out.println("RECVED " + data);
      }
      catch(IOException e) { Send_err(e +
                   "Exception reading from Server socket");
                    return;
                   }
      StringTokenizer t1 = new StringTokenizer(data, "|");

      /*Get the first integer from the header*/
      int type  = Integer.parseInt(t1.nextToken());

      if((type == 0) || (type == 1))
      {
        out.println(data);
      }
      else if(type == 2)
      {
        int file_size = Integer.parseInt(t1.nextToken());
        byte[] data1 = new byte[file_size];
        int bytes_read = 0;

        while(bytes_read < file_size)
        {
          try {
             bytes_read += in1.read
                       (data1, bytes_read, file_size-bytes_read);
          }
          catch(IOException e) { Send_err 
                                 ("Error  in Reading socket");
                                 return;
                               }
        }
        out.println(data);
        out.println(new String(data1, 0));
      }
     }
    }

    public void save_file(String req, String filename, int length)
    {
      byte[] data = new byte[length];
      int bytes_read = 0;

      while(bytes_read < length)
      {
         try {
            bytes_read += in.read(data, bytes_read, length-bytes_read);
         }
         catch(IOException e) { Send_err("Error :" + e);
                                return;
                              }
       }

       try {
         temp_url = new URL(filename);
         } catch(MalformedURLException me)
           {
            Send_err("Error in URL: " + me);
            return;
           }

       if(!temp_url.getHost().equals(""))
       {
        if(My_Server_info.Gethost(temp_url.getHost()) == null)
        {
         Send_err(
           "Error : Cannot write this file because no Server running");
         return;
        }
       }

       if((temp_url.getHost().equals(""))||
          (My_Server_info.Gethost(temp_url.getHost()).equals("myhost")))
       {
        if(temp_url.getHost().equals(""))
        {
          actual_file = temp_url.getFile();
        }
        else 
        {
         actual_file = (new StringBuffer
         (My_Server_info.Gethome())).append(temp_url.getFile()).toString();
        }

        System.out.println("ACTUAL FILE " + actual_file);

        System.out.println("ENTERED REGULAR STYLE");
        file = new File(actual_file);

        /*if ((!file.exists()) || (!file.isFile()))
        {
         Send_err("Error: no such file");
         return;
        }
        if(!file.canWrite())
        {
          Send_err("Error: unable to write file ");
          return;
        }*/

        System.out.println("RECVED " + filename);
        try {
           Fout = new FileOutputStream(actual_file);
        }
        catch(IOException e) { Send_err("Error :" + e);
                                  return;
                                }
        try {
           Fout.write(data, 0, length);
           Fout.close();
        }
        catch(IOException e) { Send_err("Error :" + e);
                                  return;
                                }
        out.println("1|FILE Written");
      }
      else
      {
      try
      {
       System.out.println(" OPENING to " + 
                          My_Server_info.Gethost(temp_url.getHost()) + 
                          " PORT " + 
                          My_Server_info.Getport(temp_url.getHost()));

        s = new Socket(My_Server_info.Gethost(temp_url.getHost()),
                             My_Server_info.Getport(temp_url.getHost()));
        in1  = new DataInputStream(s.getInputStream());
        out1 = new PrintStream(s.getOutputStream());
       }
       catch(IOException e) {
          Send_err(e + "Exception creating Final Server Socket");
          return;
       }
       out1.println(req);
       out1.write(data, 0, length);
       try {
         line1 = in1.readLine();
       }
       catch(IOException e) {
           Send_err(e + "Exception reading from Final Server Socket");
           return;
          }
       out.println(line1);
       }
    }

    public void create_dir(String req, String filename)
    {
       try {
         temp_url = new URL(filename);
         } catch(MalformedURLException me)
           {
            Send_err("Error in URL: " + me);
            return;
           }

       if(!temp_url.getHost().equals(""))
       {
        if(My_Server_info.Gethost(temp_url.getHost()) == null)
        {
         Send_err(
           "Error : Cannot create directory because no Server running");
         return;
        }
       }

       if((temp_url.getHost().equals(""))||
          (My_Server_info.Gethost(temp_url.getHost()).equals("myhost")))
       {
        if(temp_url.getHost().equals(""))
        {
          actual_file = temp_url.getFile();
        }
        else 
        {
         actual_file = (new StringBuffer
         (My_Server_info.Gethome())).append(temp_url.getFile()).toString();
        }

        System.out.println("ACTUAL FILE " + actual_file);

        System.out.println("ENTERED REGULAR STYLE");
        file = new File(actual_file);
        System.out.println("RECVED " + filename);

        if (file.exists()) 
        {
         if(file.isFile())
         {
          Send_err("Error: Existing file specified");
	  return;
         }
         else
         {
          Send_err("Directory created");
	  return;
	 }
        }
        if(!file.mkdir()) Send_err("Error : Cannot create directory");
        out.println("4|FILE Written");
      }
      else
      {
      try
      {
       System.out.println(" OPENING to " + 
                          My_Server_info.Gethost(temp_url.getHost()) + 
                          " PORT " + 
                          My_Server_info.Getport(temp_url.getHost()));

        s = new Socket(My_Server_info.Gethost(temp_url.getHost()),
                             My_Server_info.Getport(temp_url.getHost()));
        in1  = new DataInputStream(s.getInputStream());
        out1 = new PrintStream(s.getOutputStream());
       }
       catch(IOException e) {
          Send_err(e + "Exception creating Final Server Socket");
          return;
       }
       out1.println(req);
       try {
         line1 = in1.readLine();
       }
       catch(IOException e) {
           Send_err(e + "Exception reading from Final Server Socket");
           return;
          }
       out.println(line1);
      }
    }

    public void run() {
        int len;
        String token = new String();
         try {
                // read in a line
                String line = in.readLine();
                if (line == null) 
                {
                System.out.println("Error in recv of line from Applet");
                return;
                }
                else
		{
                 System.out.println("recv line " + line);
                  StringTokenizer t = new StringTokenizer(line, "|");
                  token = t.nextToken();
                  if(token.equals("OPEN"))
                  {
                   System.out.println("RECEIVED " + line + " TOKEN " + token);
                   open_file(line, t.nextToken());
                  }
                  else if(token.equals("SAVE"))
                  {
                   System.out.println("RECEIVED " + line);
                   save_file(line, t.nextToken(), 
                      Integer.parseInt(t.nextToken()));
                  }
                  if(token.equals("CREATEDIR"))
                  {
                   System.out.println("RECEIVED " + line + " TOKEN " + token);
                   create_dir(line, t.nextToken());
                  }
                  if(token.equals("Whether_Server"))
                  {
		   System.out.println("RECEIVED " + line);

                  try {
                   temp_url = new URL(t.nextToken());
                  } catch(MalformedURLException me)
                  {
                   System.out.println("Error in URL: " + me);
                   Send_err("Malformed URL");
                   return;
                  }

                 if(!temp_url.getHost().equals(""))
                 {
                 if(My_Server_info.Gethost(temp_url.getHost()) == null)
                 {
                  out.println(String.valueOf(1));
                  return;
                 }
                 else out.println(String.valueOf(2));
                 }

		  }
                 if(token.equals("RecCopyHtml"))
                 {
                   String html_source = t.nextToken();
                   String dest_dir = t.nextToken();
                   String local_sunos = t.nextToken();
System.out.println("Line " + line);
                  StringBuffer req = new StringBuffer();
		  req.append("/usr/ucb/rsh " +  local_sunos);
		  req.append(" cd " + dest_dir + "; /tony/users/sivaram/java/inde/perl/old/htget -r ");
		  req.append(html_source);
		  System.out.println("FINAL request " + req);
                  Runtime r = Runtime.getRuntime();
                  r.exec(new String(req));
                 }
		 }
        }
        catch (IOException e) {;}
        finally {try {client.close(); }catch (IOException e2){;}}
    }
}
